Enumeration
  #Win_0
EndEnumeration


Enumeration
  #File_0
EndEnumeration


Structure main
  prgname.s
  prgvers.f
  screenwidth.l
  screenheight.l
  mapwidth.l
  mapheight.l
  tilewidth.l
  tileheight.l
  layermax.l
  tilesets.l
EndStructure
Global main.main
main\prgname      = "TME-Example"
main\prgvers      = 1.0
main\screenwidth  = 1024
main\screenheight = 768


Structure tilemap
  tilesetid.l
  tilenr.l
  cx.l
  cy.l
  x.l
  y.l
  layer.l
  special.l
  frametimer.l
  totalframes.l
  framedelay.l
  loop.l
  lastcall.l
  frame.l
  deltatime.l
EndStructure
Global NewList tilemap.tilemap()


Structure tileset
  file.s[11]
  id.l[11]
  id3d.l[11]
  display.l[11]
  width.l[11]
  height.l[11]
EndStructure
Global tileset.tileset


Procedure GFX()
  If InitSprite() = #False
    MessageRequester("Info", "Konnte die DirectX-Umgebung nicht initialisieren!", #MB_ICONERROR)
    End
  EndIf
  If InitSprite3D() = #False
    MessageRequester("Info", "Konnte die DirectX-Umgebung nicht initialisieren!", #MB_ICONERROR)
    End
  EndIf
EndProcedure


Procedure LoadTilesets()
  TransparentSpriteColor(#PB_Default, RGB(0, 0, 0))
  For z0.l = 1 To main\tilesets
    If tileset\file[z0] <> ""
      tileset\id[z0]     = LoadSprite(#PB_Any, tileset\file[z0], #PB_Sprite_Texture | #PB_Sprite_Memory)
      tileset\width[z0]  = SpriteWidth(tileset\id[z0])
      tileset\height[z0] = SpriteHeight(tileset\id[z0])
      tileset\id3d[z0]   = CreateSprite3D(#PB_Any, tileset\id[z0])
    EndIf
  Next z0
EndProcedure


Procedure LoadMap(file.s)
  If ReadFile(#File_0, file)
    main\mapwidth  = ReadLong(#File_0)
    main\mapheight   = ReadLong(#File_0)
    main\tilewidth = ReadLong(#File_0)
    main\tileheight  = ReadLong(#File_0)
    If main\mapheight > 1000 Or main\mapwidth > 1000 Or main\tileheight > 1000 Or main\tilewidth > 1000
      MessageRequester("Fehler", "Konnte die Datei nicht lesen!", #MB_ICONERROR)
      ProcedureReturn #False
    EndIf
    ClearList(tilemap())
    Repeat
      daten.l = ReadLong(#File_0)
      If daten <> 12345678
        AddElement(tilemap())
        tilemap()\tilesetid   = daten
        tilemap()\tilenr      = ReadLong(#File_0)
        tilemap()\cx          = ReadLong(#File_0)
        tilemap()\cy          = ReadLong(#File_0)
        tilemap()\x           = ReadLong(#File_0)
        tilemap()\y           = ReadLong(#File_0)
        tilemap()\layer       = ReadLong(#File_0)
        tilemap()\special     = ReadLong(#File_0)
        tilemap()\totalframes = ReadLong(#File_0)
        tilemap()\frame       = ReadLong(#File_0)
        tilemap()\framedelay  = ReadLong(#File_0)
        tilemap()\loop        = ReadLong(#File_0)
        tilemap()\frametimer  = 0
        tilemap()\lastcall    = 0
        tilemap()\deltatime   = 0
      Else
        Break
      EndIf
    ForEver
    main\tilesets = 0
    For z0.l = 1 To 10
      string.s = ReadString(#File_0)
      If string <> ""
        tileset\file[z0] = string
        main\tilesets + 1
      EndIf
    Next z0
    main\layermax = tilemap()\layer
    CloseFile(#File_0)
  Else
    MessageRequester("Fehler", "Konnte die Datei nicht lesen!", #MB_ICONERROR)
    ProcedureReturn #False
  EndIf
  ProcedureReturn #True
EndProcedure


Procedure RenderAll()
  ; Tiles zeichnen/animieren
  If IsScreenActive()
    ForEach tilemap()
      If tilemap()\loop <> 0
        tilemap()\frametimer = ElapsedMilliseconds()
        If tilemap()\lastcall = 0
          tilemap()\lastcall = tilemap()\frametimer
          tilemap()\frame = 1
        EndIf
        tilemap()\deltatime = tilemap()\frametimer - tilemap()\lastcall
        While tilemap()\deltatime > tilemap()\framedelay
          If tilemap()\frame = tilemap()\totalframes
            tilemap()\frame = 0
            If tilemap()\loop <> -1
              tilemap()\loop - 1
              If tilemap()\loop < 0
                tilemap()\loop = 0
              EndIf
            EndIf
          EndIf
          tilemap()\lastcall + tilemap()\framedelay
          tilemap()\deltatime - tilemap()\framedelay
          tilemap()\frame + 1
        Wend
      Else
        tilemap()\frame = 1
      EndIf
      If IsSprite(tileset\id[tilemap()\tilesetid])
        StartSpecialFX()
        ClipSprite(tileset\id[tilemap()\tilesetid], tilemap()\cx + ((tilemap()\frame - 1) * main\tilewidth), tilemap()\cy, main\tilewidth, main\tileheight)
        DisplayTransparentSprite(tileset\id[tilemap()\tilesetid], tilemap()\x, tilemap()\y)
        StopSpecialFX()
      EndIf
    Next
  EndIf
EndProcedure


Procedure Screen()
  If OpenScreen(main\screenwidth, main\screenheight, 32, main\prgname + " v" + StrF(main\prgvers, 1)) = #True
  Else
    MessageRequester("Info", "Konnte die DirectX-Umgebung nicht initialisieren!", #MB_ICONERROR)
    End
  EndIf
EndProcedure


GFX()
UsePNGImageDecoder() ; Wird bentigt um die Tilesets zu laden
Screen() ; Screen
LoadMap("new.map") ; Karte laden
LoadTilesets() ; Tilesets laden


;- MAIN
Repeat
  If GetAsyncKeyState_(#VK_ESCAPE) Or GetAsyncKeyState_(#VK_Q)
    Break
  EndIf
  ClearScreen(RGB(0, 0, 0))
  RenderAll()
  FlipBuffers()
ForEver
End

; IDE Options = PureBasic 4.50 (Windows - x86)
; EnableXP